static DH *get_dh512(void)
{
    static unsigned char dhp_512[] = {
        0x8E, 0xFC, 0x8E, 0xA3, 0x1D, 0x97, 0x7B, 0x30, 0x1F, 0x49,
        0xCA, 0x6A, 0xAC, 0x94, 0xED, 0xD7, 0x93, 0x09, 0x9D, 0x73,
        0xF0, 0xB6, 0xC7, 0xDE, 0xA3, 0x07, 0x49, 0xA1, 0x83, 0xB2,
        0xB4, 0x6A, 0xD1, 0x6C, 0x55, 0xBB, 0xC4, 0x98, 0x76, 0x58,
        0x74, 0xAD, 0x4C, 0xCB, 0xB3, 0x68, 0xA6, 0x80, 0x06, 0x26,
        0x62, 0xD9, 0xDD, 0x10, 0x79, 0xF8, 0xC0, 0x1E, 0x29, 0xAE,
        0x4C, 0x87, 0x16, 0x83
    };
    static unsigned char dhg_512[] = {
        0x05
    };
    DH *dh = DH_new();
    BIGNUM *p, *g;

    if (dh == NULL)
        return NULL;
    p = BN_bin2bn(dhp_512, sizeof(dhp_512), NULL);
    g = BN_bin2bn(dhg_512, sizeof(dhg_512), NULL);
    if (p == NULL || g == NULL
            || !DH_set0_pqg(dh, p, NULL, g)) {
        DH_free(dh);
        BN_free(p);
        BN_free(g);
        return NULL;
    }
    return dh;
}
